//
//  SC01ViewController.m
//  SampleCode01
//
//  Created by Jp LaFond on 3/25/12.
//  Copyright (c) 2012 Jp4Mobile. All rights reserved.
//

#import "SC01ViewController.h"

// Extend the class to add some private methods
@interface SC01ViewController ()

// Private helper methods
- (void) disableUIElements;
- (void) enableUIElements;
- (void) startSpinner;
- (void) stopSpinner;

@end

@implementation SC01ViewController

// Don't forget the @synthesize or you won't get your getters/setters or definitions
@synthesize infoLabel    = _infoLabel;
@synthesize nameField    = _nameField;
@synthesize submitButton = _submitButton;
@synthesize webView      = _webView;

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    // Enable everything...
    [self enableUIElements];
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
}

// This is how you label code sections for ease of finding them in the viewer above
#pragma mark - Button Functions
- (IBAction)submitButtonPressed:(id)sender {
    // Disable everything
    [self disableUIElements];
    // Log the text field
    NSLog(@" nameField (%@)", self.nameField.text);
    // Hide keyboard
    [self.nameField resignFirstResponder];
    // Start the web search...
    [self.webView loadRequest:[NSURLRequest requestWithURL:[NSURL URLWithString:@"http://4.bp.blogspot.com/_knkvaxcxu7Q/TJaasNjB-RI/AAAAAAAAAmA/ZioPAPDhZtM/s1600/young-frankenstein.jpg"]]];
}

// This is how you label code sections for ease of finding them in the viewer above
#pragma mark - Helper Functions
- (void) disableUIElements {
    // Change the label color...
    self.infoLabel.textColor = [UIColor redColor];
    // Disable the button
    self.submitButton.enabled = NO;
    // Disable the TextField
    self.nameField.enabled = NO;
}

- (void) enableUIElements {
    // Change the label color...
    self.infoLabel.textColor = [UIColor blackColor];
    // Enable the button
    self.submitButton.enabled = YES;
    // Enable the TextField
    self.nameField.enabled = YES;
}

- (void) startSpinner {
    UIApplication * appDelegate = [UIApplication sharedApplication];
    appDelegate.networkActivityIndicatorVisible = YES;
}

- (void) stopSpinner {
    UIApplication * appDelegate = [UIApplication sharedApplication];
    appDelegate.networkActivityIndicatorVisible = NO;
}

// This is how you label code sections for ease of finding them in the viewer above
#pragma mark - UIWebViewDelegate methods
- (void)webView:(UIWebView *)webView didFailLoadWithError:(NSError *)error {
    [self startSpinner];
    
    NSLog(@"didFailLoadWithError (%@)", error);
    // Put up an error message...
    NSString * htmlString = [NSString stringWithFormat:@"<HTML>\n<BODY>\n<H1>Problem</H1>\n<P>%@</P>\n</BODY>\n</HTML>", error.localizedDescription];
    [webView loadHTMLString:htmlString baseURL:nil];
}

- (void)webViewDidStartLoad:(UIWebView *)webView {
    [self startSpinner];
}

- (void)webViewDidFinishLoad:(UIWebView *)webView {
    [self stopSpinner];
}

// This is how you label code sections for ease of finding them in the viewer above
#pragma mark - UITextFieldDelegate methods
- (BOOL)textFieldShouldReturn:(UITextField *)textField {
    // Remove the keyboard
    [textField resignFirstResponder];
    return YES;
}

@end
